/*
 * API documentation
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0.0-20181108155220-20181108155343
 * Contact: api.move@axa-assistance.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.insurance.bn.starter.model;

import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import org.threeten.bp.LocalDate;

import java.util.Objects;

/**
 * Information related to the travel.
 */
@ApiModel(description = "Information related to the travel.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2018-12-19T23:23:06.995+01:00")
public class TravelInformation {
  @SerializedName("from_date")
  private LocalDate fromDate = null;

  @SerializedName("to_date")
  private LocalDate toDate = null;

  @SerializedName("travel_agency")
  private Agency travelAgency = null;

  @SerializedName("was_the_baggage_in_the_charge_of_the_travel_company")
  private Boolean wasTheBaggageInTheChargeOfTheTravelCompany = null;

  @SerializedName("transportation_type")
  private String transportationType = null;

  @SerializedName("transportation_id")
  private String transportationId = null;

  @SerializedName("is_full_charged_on_card")
  private Boolean isFullChargedOnCard = null;

  public TravelInformation fromDate(LocalDate fromDate) {
    this.fromDate = fromDate;
    return this;
  }

   /**
   * Date and time the trip starts. UTC datetime, RFC3339 format (YYYY-MM-DDTHH:mm:ssZ).
   * @return fromDate
  **/
  @ApiModelProperty(value = "Date and time the trip starts. UTC datetime, RFC3339 format (YYYY-MM-DDTHH:mm:ssZ).")
  public LocalDate getFromDate() {
    return fromDate;
  }

  public void setFromDate(LocalDate fromDate) {
    this.fromDate = fromDate;
  }

  public TravelInformation toDate(LocalDate toDate) {
    this.toDate = toDate;
    return this;
  }

   /**
   * Date and time the trip ends. UTC datetime, RFC3339 format (YYYY-MM-DDTHH:mm:ssZ).
   * @return toDate
  **/
  @ApiModelProperty(value = "Date and time the trip ends. UTC datetime, RFC3339 format (YYYY-MM-DDTHH:mm:ssZ).")
  public LocalDate getToDate() {
    return toDate;
  }

  public void setToDate(LocalDate toDate) {
    this.toDate = toDate;
  }

  public TravelInformation travelAgency(Agency travelAgency) {
    this.travelAgency = travelAgency;
    return this;
  }

   /**
   * Get travelAgency
   * @return travelAgency
  **/
  @ApiModelProperty(value = "")
  public Agency getTravelAgency() {
    return travelAgency;
  }

  public void setTravelAgency(Agency travelAgency) {
    this.travelAgency = travelAgency;
  }

  public TravelInformation wasTheBaggageInTheChargeOfTheTravelCompany(Boolean wasTheBaggageInTheChargeOfTheTravelCompany) {
    this.wasTheBaggageInTheChargeOfTheTravelCompany = wasTheBaggageInTheChargeOfTheTravelCompany;
    return this;
  }

   /**
   * Is the baggage in charge of travel company?
   * @return wasTheBaggageInTheChargeOfTheTravelCompany
  **/
  @ApiModelProperty(value = "Is the baggage in charge of travel company?")
  public Boolean isWasTheBaggageInTheChargeOfTheTravelCompany() {
    return wasTheBaggageInTheChargeOfTheTravelCompany;
  }

  public void setWasTheBaggageInTheChargeOfTheTravelCompany(Boolean wasTheBaggageInTheChargeOfTheTravelCompany) {
    this.wasTheBaggageInTheChargeOfTheTravelCompany = wasTheBaggageInTheChargeOfTheTravelCompany;
  }

  public TravelInformation transportationType(String transportationType) {
    this.transportationType = transportationType;
    return this;
  }

   /**
   * Means of transportation used for this trip. Expected values (AIRCRAFT, RAILWAY, SHIP)
   * @return transportationType
  **/
  @ApiModelProperty(value = "Means of transportation used for this trip. Expected values (AIRCRAFT, RAILWAY, SHIP)")
  public String getTransportationType() {
    return transportationType;
  }

  public void setTransportationType(String transportationType) {
    this.transportationType = transportationType;
  }

  public TravelInformation transportationId(String transportationId) {
    this.transportationId = transportationId;
    return this;
  }

   /**
   * Identifier of the means of transportation.
   * @return transportationId
  **/
  @ApiModelProperty(example = "Aircraft flight number.", value = "Identifier of the means of transportation.")
  public String getTransportationId() {
    return transportationId;
  }

  public void setTransportationId(String transportationId) {
    this.transportationId = transportationId;
  }

  public TravelInformation isFullChargedOnCard(Boolean isFullChargedOnCard) {
    this.isFullChargedOnCard = isFullChargedOnCard;
    return this;
  }

   /**
   * Is the trip full charged on your credit card?
   * @return isFullChargedOnCard
  **/
  @ApiModelProperty(value = "Is the trip full charged on your credit card?")
  public Boolean isIsFullChargedOnCard() {
    return isFullChargedOnCard;
  }

  public void setIsFullChargedOnCard(Boolean isFullChargedOnCard) {
    this.isFullChargedOnCard = isFullChargedOnCard;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    TravelInformation travelInformation = (TravelInformation) o;
    return Objects.equals(this.fromDate, travelInformation.fromDate) &&
        Objects.equals(this.toDate, travelInformation.toDate) &&
        Objects.equals(this.travelAgency, travelInformation.travelAgency) &&
        Objects.equals(this.wasTheBaggageInTheChargeOfTheTravelCompany, travelInformation.wasTheBaggageInTheChargeOfTheTravelCompany) &&
        Objects.equals(this.transportationType, travelInformation.transportationType) &&
        Objects.equals(this.transportationId, travelInformation.transportationId) &&
        Objects.equals(this.isFullChargedOnCard, travelInformation.isFullChargedOnCard);
  }

  @Override
  public int hashCode() {
    return Objects.hash(fromDate, toDate, travelAgency, wasTheBaggageInTheChargeOfTheTravelCompany, transportationType, transportationId, isFullChargedOnCard);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class TravelInformation {\n");
    
    sb.append("    fromDate: ").append(toIndentedString(fromDate)).append("\n");
    sb.append("    toDate: ").append(toIndentedString(toDate)).append("\n");
    sb.append("    travelAgency: ").append(toIndentedString(travelAgency)).append("\n");
    sb.append("    wasTheBaggageInTheChargeOfTheTravelCompany: ").append(toIndentedString(wasTheBaggageInTheChargeOfTheTravelCompany)).append("\n");
    sb.append("    transportationType: ").append(toIndentedString(transportationType)).append("\n");
    sb.append("    transportationId: ").append(toIndentedString(transportationId)).append("\n");
    sb.append("    isFullChargedOnCard: ").append(toIndentedString(isFullChargedOnCard)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

